// ASMCompare.cpp: implementation of the CASMCompare class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
//#include "CompareASM.h"
#include "ASMCompare.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#include <math.h>

const char CASMCompare::whites[] = {'[',']',':',','};
const char CASMCompare::rwords[][12] = {"mov","add"};
const char CASMCompare::irwords[][12] = {"ideal","tiny"};


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


int CASMCompare::getLine(CString & str,int from=0)
{
	for (; from < str.GetLength(); from++)
		if ( (str[from] == '\r') && (str[from+1] == '\n') ) break;
	return from;
}

int CASMCompare::readSource(CString & src, int which)
{
	int line,eline,wl;

	for(int i=0; i<sizeof(his[0])/sizeof(his[0][0]); i++)
		his[which][i] = 0;

	src.MakeLower();

	for(line=0; line < src.GetLength();)
	{
		eline = getLine(src,line);
		while (line < eline)
		{
			while ((line < eline) && isWhite(src[line])) line++;
			if (line >= eline) { line = eline; continue; }
			for(wl=0; (wl+line < eline) && !isWhite(src[line+wl]) && src[line+wl]!=';'; wl++);
			if (src[line] == ';') 
			{
				line = eline;
				continue;
			}
			checkWord(src,line,wl,which);
			line += wl;	
		}
		line += 2;
	}

	return 0;
}

double CASMCompare::compare()
{
	double dif,ent=0.0;
	int sn[2],i,j;

	for(j=0; j<2; j++)	
		for(i=0,sn[j]=0; i<sizeof(his[0])/sizeof(his[0][0]); i++)
			sn[j] += his[j][i];
	


	for(i=0; i<sizeof(his[0])/sizeof(his[0][0]); i++)
	{
		dif = ((double)his[0][i])/sn[0] - ((double)his[1][i])/sn[1];		
		dif = fabs(dif);
		if (dif < 0.00000000000001) dif = 0.00000000000001;
		ent += dif * log(dif);
	}
	
	ent /= log(sizeof(his[0])/sizeof(his[0][0]));

	return 1+ent;
}

bool CASMCompare::isWhite(char chr)
{
	if (chr <= ' ') return true;
	for (int i=0; i<sizeof(whites); i++)
		if (chr == whites[i]) return true;
	return false;
}

void CASMCompare::checkWord(CString & str, int from, int len, int which)
{
	int i;

	CString word = str.Mid(from,len);

	for (i=0; i<sizeof(irwords)/sizeof(irwords[0]); i++)
		if (!word.Compare(irwords[i])) return;

	for (i=0; i<sizeof(rwords)/sizeof(rwords[0]); i++)
		if (!word.Compare(rwords[i])) break;

	if (i < sizeof(rwords)/sizeof(rwords[0]))
	{ 
		++his[which][i]; 
		return; 
	}

	for(i=0; i<word.GetLength(); i++)
		if ( (str[i]>= 'a') && (str[i] <= 'z') ) 
			++his[which][str[i] - 'a' + sizeof(rwords)/sizeof(rwords[0])];
				
}