// Hodnot.cpp: implementation of the CHodnot class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SOJ.h"
#include "Hodnot.h"
#include "ASMCompare.h"
#include "test.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHodnot::CHodnot()
{
	lst=NULL;
}

CHodnot::~CHodnot()
{

}

double CHodnot::Porovn(long idZad)
{
	CString strSql,strFile1,strFile2,strMsg,strName,strPorovn;
	_variant_t var;
	CASMCompare pPorov;
	long idUloha,nKruzok;
	double dZhoda;
	int nRange     = AfxGetApp()->GetProfileInt("Settings","CompareRange",0);
	int nInsert    = AfxGetApp()->GetProfileInt("Settings","CompareInsert",50);
	int nHighLight = AfxGetApp()->GetProfileInt("Settings","CompareHighlight",95);

	try
	{
		_RecordsetPtr rs_zad;
		rs_zad.CreateInstance(__uuidof(Recordset));
		rs_zad->CursorLocation = adUseClient;
		strSql.Format("id_zadanie = %ld",idZad,1);
		rs_zad->Filter=_variant_t(strSql);
		rs_zad->Open(L"SELECT * from zad_text",db.GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);

		if(!rs_zad->adoEOF)
		{
			READSTRING(rs_zad,"text",strFile1,var);
			READSTRING(rs_zad,"priezvisko",strMsg,var);
			idUloha = rs_zad->GetCollect("id_uloha");
			nKruzok = rs_zad->GetCollect("kruzok");
			if(nRange==0)
				strPorovn.Format("AND kruzok=%ld",nKruzok);
			else
				strPorovn.Empty();
			pPorov.readSource(strFile1,0);

			m_strVysl="Porovnanie vypracovanch zadan :";
			lst->AddString(m_strVysl);
			m_strVysl=" - tudent "+strMsg+" zadanie ";

			READSTRING(rs_zad,"nazov",strMsg,var);
			m_strVysl+=strMsg;
			lst->AddString(m_strVysl);
		}
		strSql.Format("id_zadanie <> %ld AND id_uloha = %ld %s",idZad,idUloha,strPorovn);
		rs_zad->Filter=_variant_t(strSql);
		
		while(!rs_zad->adoEOF)
		{
			READSTRING(rs_zad,"text",strFile2,var);
			READSTRING(rs_zad,"priezvisko",strName,var);
			pPorov.readSource(strFile2,1);
			dZhoda = pPorov.compare()*100;
			strMsg.Format("\t %s - zhoda  %3.2lf%%",strName,dZhoda);
			if(dZhoda>nInsert)
			{
				if(dZhoda>nHighLight)
					lst->AddString(strMsg,RGB(255,0,0));
				else
					lst->AddString(strMsg);

			}
			rs_zad->MoveNext();
		}
		rs_zad->Close();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		AfxMessageBox(IDS_EXCEPTION);
	}	
	return 1.0;

}

int CHodnot::Test(long idZad)
{
	CString strSql,strFile1,strFile2,strMsg,strName,strPorovn,strVstup;
	_variant_t var;
	test pTest;

	CString strComp     = AfxGetApp()->GetProfileString("Settings","Compiler","");
	CString strCompPar  = AfxGetApp()->GetProfileString("Settings","CompilerParam","");
	CString strLink		= AfxGetApp()->GetProfileString("Settings","Linker","");
	CString strLinkPar	= AfxGetApp()->GetProfileString("Settings","LinkerParam","");
	strComp+=" "+strCompPar;
	strLink+=" "+strLinkPar;
	strComp.TrimRight(' ');
	strLink.TrimRight(' ');

	try
	{
		long nUloha;
		_RecordsetPtr rs_zad;
		rs_zad.CreateInstance(__uuidof(Recordset));
		rs_zad->CursorLocation = adUseClient;
		strSql.Format("id_zadanie = %ld",idZad);
		rs_zad->Filter=_variant_t(strSql);
		rs_zad->Open(L"SELECT * from zad_text",db.GetInterfacePtr(),
			adOpenStatic,adLockReadOnly,adCmdText);
		if(!rs_zad->adoEOF)
		{
			READSTRING(rs_zad,"text",strFile1,var);
			READSTRING(rs_zad,"priezvisko",strMsg,var);
			nUloha=rs_zad->GetCollect(L"id_uloha");

		}
		rs_zad->Close();
		strSql.Format("id_uloha = %ld",nUloha);
		rs_zad->Filter=_variant_t(strSql);
		rs_zad->Open(L"SELECT * from uloha",db.GetInterfacePtr(),
			adOpenStatic,adLockReadOnly,adCmdText);
		if(!rs_zad->adoEOF)
		{
			READSTRING(rs_zad,"vzor",strFile2,var);
			READSTRING(rs_zad,"vstupy",strVstup,var);
		}
		rs_zad->Close();

	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
		return 0;
	}
	catch(...)
	{
		AfxMessageBox(IDS_EXCEPTION);
		return 0;
	}	

	m_strVysl="Testovanie zadania";
	lst->AddString(m_strVysl);
	m_strVysl=" - tudent "+strMsg+" zadanie ";

	m_strVysl+=strMsg;
	lst->AddString(m_strVysl);

	CFile fTest;
	fTest.Open("temp1.asm",CFile::modeWrite|CFile::modeCreate);
	fTest.WriteHuge(strFile1,strFile1.GetLength());
	fTest.Close();
	fTest.Open("temp2.asm",CFile::modeWrite|CFile::modeCreate);
	fTest.WriteHuge(strFile2,strFile2.GetLength());
	fTest.Close();
	
	pTest.nastav(strComp.GetBuffer(strComp.GetLength()),"",1);
	pTest.nastav(strLink.GetBuffer(strLink.GetLength()),"",2);
	if(!strFile2.IsEmpty())
	{
//		pTest.nastav("temp2",strVstup.GetBuffer(strVstup.GetLength()));
	}
	if(pTest.testuj("temp1",strVstup.GetBuffer(strVstup.GetLength()))==0)
	{
		m_strVysl="\tzadanie v poriadku";
		lst->AddString(m_strVysl);
	}
	else
	{
		m_strVysl="\tzadanie nie je v poriadku";
		lst->AddString(m_strVysl);
	}
//	CFile::Remove("temp1.asm");CFile::Remove("temp2.asm");
//	CFile::Remove("temp1.obj");CFile::Remove("temp2.obj");
//	CFile::Remove("temp1.exe");CFile::Remove("temp2.exe");
	
	return 1;

}
