// ImportMedDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SOJ.h"
#include "ImportMedDlg.h"
#include "ErrorReportDlg.h"
#include <io.h>
#include "BrowseFolder.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImportMedDlg dialog


CImportMedDlg::CImportMedDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImportMedDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CImportMedDlg)
	m_strPath = _T("");
	m_bCheck = FALSE;
	//}}AFX_DATA_INIT
}


void CImportMedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CImportMedDlg)
	DDX_Control(pDX, IDC_LIST, m_lstZad);
	DDX_Text(pDX, IDC_PATH, m_strPath);
	DDX_Check(pDX, IDC_CHECK1, m_bCheck);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CImportMedDlg, CDialog)
	//{{AFX_MSG_MAP(CImportMedDlg)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImportMedDlg message handlers CListBox

void CImportMedDlg::OnBrowse() 
{
	CString strText2,strPath;
	CBrowseFolder sb(m_hWnd,IDS_IMPORTMED);
	sb.SetInitialSelection(m_strPath);
	if(!sb.SelectFolder())
	{
		return;
	}
	strPath = sb.GetSelectedFolder();
	SetDlgItemText( IDC_PATH, strPath);
	if(strPath.IsEmpty())
	{
		return;
	}
	GetDlgItem(IDOK)->EnableWindow(TRUE);
	CFileFind finder;
	BOOL bWorking = finder.FindFile( strPath+_T("\\*.*") );
	_variant_t varValue;
	long nIdStud;
	CString strVal;
	while (bWorking)
	{
		bWorking = finder.FindNextFile();
		if( finder.IsDots() )
			continue;
		if( finder.IsDirectory() )
		{
			strVal=finder.GetFileName();
			if(atoi(strVal)==0)
				continue;
			CString strFind;
			strFind.Format("id_student=%s",finder.GetFileName());
			rs->MoveFirst();
			rs->Find(bstr_t(strFind),0,adSearchForward);
			if(!(rs->adoEOF))
			{
				varValue = rs->GetCollect(L"id_student");
				nIdStud = atoi((char*)_bstr_t(varValue));
				varValue = rs->GetCollect(L"priezvisko");
				strText2 = GETSTRING(varValue);
				strVal+=" - "+strText2+" ";
				varValue = rs->GetCollect(L"meno");
				strText2 = GETSTRING(varValue);
				strVal+=strText2;

				int id = m_lstZad.InsertString(-1,strVal);
				m_lstZad.SetItemData (id,nIdStud);
				m_lstZad.SetCheck(id,1);
			}
		}
	}
}


void CImportMedDlg::OnOK() 
{
//	m_im
	long id;
	_variant_t varValue;
	CFileFind fFiles;
	CString strZadPath;
	CFile fZadanie;
	UpdateData();

	for(int i=0;i<m_lstZad.GetCount();i++)
	{
		if(m_lstZad.GetCheck(i))
		{
			id = m_lstZad.GetItemData(i);
			CString strFind;
			strFind.Format("id_student=%05ld",id);
			rs->MoveFirst();
			rs->Find(bstr_t(strFind),0,adSearchForward);
			
			if(!(rs->adoEOF))
			{
				strZadPath.Format("%s\\%5ld\\*.asm",m_strPath,id);
				BOOL bWorking = fFiles.FindFile( strZadPath );
				while (bWorking)
				{
					bWorking = fFiles.FindNextFile();
					if( fFiles.IsDots() )
						continue;
					AddFile(fFiles.GetFilePath(),id);
				}
			}

		}
	}
	CDialog::OnOK();
	rs->Close();
	rs_zad->Close();

}

BOOL CImportMedDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	rs.CreateInstance(__uuidof(Recordset));
	rs->CursorLocation = adUseClient;
	rs->Open("SELECT * from student",db.GetInterfacePtr(),
		adOpenDynamic,
		adLockOptimistic,
		adCmdText);
	rs_zad.CreateInstance(__uuidof(Recordset));
	rs_zad->CursorLocation = adUseClient;
	rs_zad->Open("SELECT * from zadanie",db.GetInterfacePtr(),
		adOpenDynamic,
		adLockOptimistic,
		adCmdText);
	m_bCheck = AfxGetApp()->GetProfileInt("Settings","HromMed",0);
	UpdateData(FALSE);
	return TRUE;
}

void CImportMedDlg::AddFile(CString sFile, long nId)
{
	_variant_t var;
	CString strAll,strLine,strTmp;;
	CStdioFile file(sFile,CFile::modeRead);
	COleDateTime datum=COleDateTime::GetCurrentTime();
	BOOL isFile=FALSE;
	long nLineNo = 0,nIdStud,nIdZad;
	CString strStud,strZad;
	strTmp = "0123456789";
	while(file.ReadString(strLine))
	{
		switch(nLineNo)
		{
		case 0:
			SPANINCLUDING(strLine,strTmp,strStud);
			if(!strStud.IsEmpty())
				nIdStud = atoi(strStud);
			else
				nIdStud = 0;

			break;
		case 1:
			SPANINCLUDING(strLine,strTmp,strZad);
			if(!strZad.IsEmpty())
				nIdZad = atoi(strZad);
			else
				nIdZad = 0;
			break;
		default:
			strAll+="\r\n"+strLine;
			break;
		}
		nLineNo++;
	}
	file.Close();
	if(nIdStud==0 || nIdZad==0)
		return;

	try
	{
		rs_zad->AddNew();
		var = strStud;
		rs_zad->GetFields()->GetItem(L"id_student")->Value = var;
		var.vt=VT_I4;
		var.lVal=nIdZad;
		rs_zad->GetFields()->GetItem(L"id_uloha")->Value = var;
		var = strAll;
		rs_zad->GetFields()->GetItem(L"text")->Value = var;
		var = datum;
		rs_zad->GetFields()->GetItem(L"datum")->Value = var;
		var = false;
		rs_zad->GetFields()->GetItem(L"hodnot")->Value = var;

		rs_zad->Update();
	}

	catch(CException *e)
	{
		e->ReportError();
	}
	catch(_com_error &e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(db).DoModal();
	}	


}

BOOL CImportMedDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return HtmlHelp(
		NULL,
		"sojko.chm::/medium.htm",HH_DISPLAY_TOPIC,0
		)!=0;
}
