// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SOJ.h"
#include "MainFrm.h"
#include "StudentView.h"
#include "ZadanieView.h"
#include "UlohaView.h"
#include "KonfigDlg.h"
#include "Splash.h"
#include "VyberSkRokDlg.h"
#include "SOJDoc.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_KONFIG, OnKonfig)
	ON_WM_SIZING()
	ON_COMMAND(ID_VYBER_ROK, OnVyberRok)
	ON_COMMAND(ID_POMOC, OnPomoc)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
//	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC,CRect(0,0,0,0),AFX_IDW_TOOLBAR) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}


	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
//	m_wndTool1.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
//	CRect rect(0,0,500,50);
//	ClientToScreen(&rect);
	DockControlBar(&m_wndToolBar);//,AFX_IDW_DOCKBAR_TOP,rect);
//	m_wndToolBar.GetClientRect(rect);
//	rect+=CPoint(300,0);
//	ClientToScreen(&rect);
//	DockControlBar(&m_wndTool1,AFX_IDW_DOCKBAR_TOP,rect);
	
	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::ShowSplashScreen(this);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	if (!m_wndSplitter.Create(this, IDI_STUDENT, IDS_STUDENT, pContext))
		return FALSE;

	// Don't send initial update
	if (!m_wndSplitter.AddView(IDI_ULOHA, IDS_ULOHA,
								RUNTIME_CLASS(CUlohaView), FALSE))
		return FALSE;

	if (!m_wndSplitter.AddView(IDI_ZADANIE, IDS_ZADANIE,
								RUNTIME_CLASS(CZadanieView), FALSE))
		return FALSE;

	switch(AfxGetApp()->GetProfileInt("Settings","DefView",0))
	{
	case 0:
		m_wndSplitter.SwitchToView(IDI_STUDENT);
		break;
	case 1:
		m_wndSplitter.SwitchToView(IDI_ULOHA);
		break;
	case 2:
		m_wndSplitter.SwitchToView(IDI_ZADANIE);
		break;
	}
	

	return TRUE ; 
}

void CMainFrame::OnKonfig() 
{
	CKonfigDlg dlg;
	dlg.DoModal();	
}

void CMainFrame::OnSizing(UINT fwSide, LPRECT pRect) 
{
//	CFrameWnd::OnSizing(fwSide, pRect);
	if( pRect->right < 500 )
		pRect->right = 500;
	if( pRect->bottom < 370 )
		pRect->bottom = 370;

}

void CMainFrame::OnVyberRok() 
{
	CVyberSkRokDlg dlg;
	int nCurId = m_wndSplitter.GetCurrentId();

	NMHDR hdr;
	hdr.hwndFrom = m_hWnd;
	hdr.idFrom = WM_USER;
	hdr.code=0;
	m_wndSplitter.SwitchToView(IDI_ULOHA);
	m_wndSplitter.GetPane(0,1)->SendMessage(WM_NOTIFY,WM_USER,(long)&hdr);
	m_wndSplitter.SwitchToView(IDI_STUDENT);
	m_wndSplitter.GetPane(0,1)->SendMessage(WM_NOTIFY,WM_USER,(long)&hdr);
	m_wndSplitter.SwitchToView(IDI_ZADANIE);
	m_wndSplitter.GetPane(0,1)->SendMessage(WM_NOTIFY,WM_USER,(long)&hdr);
	
	if(dlg.DoModal()==IDOK)
	{
		((CSOJDoc*)(GetActiveView()->GetDocument()))->VyberRok(dlg.m_nRok);
	}
	hdr.code=1;
	m_wndSplitter.SwitchToView(IDI_ULOHA);
	m_wndSplitter.GetPane(0,1)->SendMessage(WM_NOTIFY,WM_USER,(long)&hdr);
	m_wndSplitter.SwitchToView(IDI_STUDENT);
	m_wndSplitter.GetPane(0,1)->SendMessage(WM_NOTIFY,WM_USER,(long)&hdr);
	m_wndSplitter.SwitchToView(IDI_ZADANIE);
	m_wndSplitter.GetPane(0,1)->SendMessage(WM_NOTIFY,WM_USER,(long)&hdr);
	m_wndSplitter.SwitchToView(nCurId);
}

void CMainFrame::OnPomoc() 
{
	HtmlHelp(NULL,"sojko.chm::/ovladanie.htm",HH_DISPLAY_TOPIC,0);
}
