// UlohaView.cpp : implementation file
//

#include "stdafx.h"
#include "SOJ.h"
#include "UlohaView.h"
#include "SOJDoc.h"
#include "EditUloha.h"
#include "ErrorReportDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUlohaView

IMPLEMENT_DYNCREATE(CUlohaView, CFormView)

CUlohaView::CUlohaView()
	: CFormView(CUlohaView::IDD)
{
	//{{AFX_DATA_INIT(CUlohaView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CUlohaView::~CUlohaView()
{
}

void CUlohaView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUlohaView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CUlohaView, CFormView)
	//{{AFX_MSG_MAP(CUlohaView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_COMMAND(ID_REFRESH, OnRefresh)
	ON_WM_HELPINFO()
	ON_COMMAND(ID_ADD, OnAdd)
	ON_COMMAND(ID_EDIT, OnEdit)
	ON_COMMAND(ID_DEL, OnDel)
	ON_NOTIFY(DGN_DBLCLICKED, 60666, OnDblClick)
	ON_NOTIFY(DGN_COLUMNCLICK, 60666, OnColumnClick)
	ON_COMMAND(ID_HELP, OnHelp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUlohaView diagnostics

#ifdef _DEBUG
void CUlohaView::AssertValid() const
{
	CFormView::AssertValid();
}

void CUlohaView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CUlohaView message handlers

void CUlohaView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	CSOJDoc * pDoc = (CSOJDoc*)GetDocument();
	GetDlgItem(IDC_ADD)->GetClientRect(m_btnRect);
	CStringArray m_aNames,m_aColumns;
	m_aNames.Add("Nzov");
	m_aColumns.Add("nazov");
	m_aNames.Add("Body");
	m_aColumns.Add("body");
	m_aNames.Add("Dtum");
	m_aColumns.Add("datum");
	m_aNames.Add("Poznmky");
	m_aColumns.Add("poznamky");
	try
	{
		m_rs.CreateInstance(__uuidof(Recordset));
//		m_rs->CursorLocation=adUseClient;
		m_rs->Open("SELECT * from uloha",
			pDoc->m_db.GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);

		m_oGrid.OpenQuery(m_rs,m_aColumns,m_aNames);
		m_oGrid.SetColWidth(0,180);
		m_oGrid.SetColWidth(1,60);
		m_oGrid.SetColAlign(1,HDF_RIGHT );
		m_oGrid.SetColWidth(2,60);
		m_oGrid.SetColAlign(2,HDF_RIGHT );
		m_oGrid.SetColWidth(3,150);

	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{	
		MessageBox("Whoa this is bad");
	}
	
}

int CUlohaView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_oGrid.Create(this, 60666, WS_CHILD | WS_TABSTOP, WS_EX_CLIENTEDGE, CRect(0,0,110,110)))
		return -1;
	
	return 0;
}

void CUlohaView::OnSize(UINT nType, int cx, int cy) 
{
	
	if(m_btnRect.bottom>0)
	{
		m_oGrid.MoveWindow(5,5,cx-10,cy-20-m_btnRect.bottom);
		GetDlgItem(IDC_ADD)->
			MoveWindow(5,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_EDIT)->
			MoveWindow(10+m_btnRect.right,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_DEL)->
			MoveWindow(5+2*m_btnRect.right+10,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);

	}
	
}

void CUlohaView::OnAdd() 
{
	CEditUloha dlg;
	_variant_t var;
	if(dlg.DoModal()==IDOK)
	{
		try
		{
			m_rs->AddNew();

			var.vt   = VT_DATE;
			var.date = dlg.m_datOd;
			dlg.m_datOd.SetDate(dlg.m_datOd.GetYear(),dlg.m_datOd.GetMonth(),dlg.m_datOd.GetDay());
			m_rs->GetFields()->GetItem(_variant_t("datum"))->Value = var;
			var.vt=VT_I4;
			var.lVal=dlg.m_nBody;
			m_rs->GetFields()->GetItem(_variant_t("body"))->Value = var;
			var = dlg.m_strNazov;
			m_rs->GetFields()->GetItem(_variant_t("nazov"))->Value = var;
			var = dlg.m_strPozn;
			m_rs->GetFields()->GetItem(_variant_t("poznamky"))->Value = var;
			var = dlg.m_strText;
			m_rs->GetFields()->GetItem(_variant_t("text"))->Value = var;
			var = dlg.m_strVzor;
			m_rs->GetFields()->GetItem(_variant_t("vzor"))->Value = var;
			var = dlg.m_strVstup;
			m_rs->GetFields()->GetItem(_variant_t("vstupy"))->Value = var;
			var = dlg.m_strVystup;
			m_rs->GetFields()->GetItem(_variant_t("vystupy"))->Value = var;
			var = dlg.m_strKonstr;
			m_rs->GetFields()->GetItem(_variant_t("konstrukcie"))->Value = var;
			dlg.m_datOd.SetDate(dlg.m_datOd.GetYear(),dlg.m_datOd.GetMonth(),dlg.m_datOd.GetDay());

			m_rs->Update();
//			m_rs->MoveFirst();
//			m_rs->MoveLast();
			m_oGrid.BindReQuery(TRUE);
		}
		catch(_com_error *e)
		{
			AfxMessageBox(e->ErrorMessage());
		}
		catch(...)
		{
			CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		}	
	}
}

void CUlohaView::OnEdit() 
{
	if(!m_oGrid.IsBound())
		return;
	CEditUloha dlg;
	_variant_t var;
	long varId;
	try
	{
		varId = m_oGrid.GetFieldValueLong("id_uloha");
		
		var = m_rs->GetCollect("body");
		ASSERT(var.vt   == VT_I4 );
		dlg.m_nBody = var.lVal;
	
		var = m_rs->GetCollect("nazov");
		dlg.m_strNazov = (char*)((_bstr_t)(var));
		var = m_rs->GetCollect("poznamky");
		dlg.m_strPozn = (char*)((_bstr_t)(var));
		
		
		var = m_rs->GetCollect("datum");
		ASSERT(var.vt == VT_DATE);
		dlg.m_datOd = var.date;

		var = m_rs->GetCollect("text");
		dlg.m_strText = (char*)((_bstr_t)(var));
		var = m_rs->GetCollect("vzor");
		dlg.m_strVzor = (char*)((_bstr_t)(var));
		var = m_rs->GetCollect("vstupy");
		dlg.m_strVstup = (char*)((_bstr_t)(var));
		var = m_rs->GetCollect("vystupy");
		dlg.m_strVystup = (char*)((_bstr_t)(var));
		var = m_rs->GetCollect("konstrukcie");
		dlg.m_strKonstr = (char*)((_bstr_t)(var));

	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
		return;
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		return;
	}	

	if(dlg.DoModal()==IDOK)
	{
		try
		{
			BOOL found=FALSE;
			m_rs->MoveFirst();
			while(!m_rs->adoEOF)
			{
				if(	varId == (long)m_rs->GetCollect("id_uloha"))
				{
					found = TRUE;
					break;
				}
				m_rs->MoveNext();
			}
			if(!found) return;

			var=(long)dlg.m_nBody;//)VT_I4;
//			var.lVal=dlg.m_nBody;
			m_rs->GetFields()->GetItem(_variant_t("body"))->Value = var;
			var = dlg.m_strNazov;
			m_rs->GetFields()->GetItem(_variant_t("nazov"))->Value = var;
			var = dlg.m_strPozn;
			m_rs->GetFields()->GetItem(_variant_t("poznamky"))->Value = var;
			var = dlg.m_strText;
			m_rs->GetFields()->GetItem(_variant_t("text"))->Value = var;
			var = dlg.m_strVzor;
			m_rs->GetFields()->GetItem(_variant_t("vzor"))->Value = var;
			var = dlg.m_strVstup;
			m_rs->GetFields()->GetItem(_variant_t("vstupy"))->Value = var;
			var = dlg.m_strVystup;
			m_rs->GetFields()->GetItem(_variant_t("vystupy"))->Value = var;
			var = dlg.m_strKonstr;
			m_rs->GetFields()->GetItem(_variant_t("konstrukcie"))->Value = var;
			var.vt   = VT_DATE;
			dlg.m_datOd.SetDate(dlg.m_datOd.GetYear(),dlg.m_datOd.GetMonth(),dlg.m_datOd.GetDay());
			var.date = dlg.m_datOd;
			m_rs->GetFields()->GetItem(_variant_t("datum"))->Value = var;

			m_rs->Update();

			m_oGrid.BindReQuery();
		}
		catch(_com_error *e)
		{
			AfxMessageBox(e->ErrorMessage());
		}
		catch(...)
		{
			CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		}	
	}
}

void CUlohaView::OnDel() 
{
	if(!m_oGrid.IsBound())
		return;
	m_oGrid.EnableWindow(FALSE);
	if(AfxMessageBox("Naozaj si elte vymaza lohu ?",MB_YESNO|MB_DEFBUTTON2)==IDYES)
	{
		try
		{
			long id_student = m_oGrid.GetFieldValueLong("id_uloha");
			BOOL found=FALSE;
			m_rs->MoveFirst();
			while(!m_rs->adoEOF)
			{
				if(	id_student == (long)m_rs->GetCollect("id_uloha"))
				{
					found = TRUE;
					break;
				}
				m_rs->MoveNext();
			}
			if(!found) return;
			m_rs->Delete(adAffectCurrent);
//			m_rs->Update();
			m_oGrid.BindReQuery(TRUE);
			//Refresh();
		}
		catch(_com_error *e)
		{
			AfxMessageBox(e->ErrorMessage());
		}
		catch(...){	CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();}	
	}
	m_oGrid.EnableWindow();
}

BOOL CUlohaView::DestroyWindow() 
{
	m_rs->Close();	
	delete m_rs;
	return CFormView::DestroyWindow();
}

void CUlohaView::OnDblClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnEdit();
}

void CUlohaView::OnRefresh() 
{
	m_rs->Requery(NULL);
	m_rs->MoveFirst();
	m_oGrid.BindReQuery();
}

void CUlohaView::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_ADOGRID * nmg = (NM_ADOGRID*)pNMHDR;
	CSOJDoc * pDoc = (CSOJDoc*)GetDocument();
	CString strSql;
	try
	{
		m_rs->Close();
		strSql = "SELECT * from uloha ORDER BY "+nmg->strCol;
		m_rs->Open(_variant_t(strSql),
			pDoc->m_db.GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);
		m_rs->MoveFirst();
		m_oGrid.BindReQuery();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db,this).DoModal();
	}	
}

BOOL CUlohaView::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	if(wParam==WM_USER)
	{
		if(((NMHDR*)lParam)->code==0)
		{
			m_oGrid.CleanUp();
			m_rs->Close();
		}
		else
		{
			OnInitialUpdate();
			m_oGrid.Invalidate();
		}
	}
	return CFormView::OnNotify(wParam, lParam, pResult);
}

BOOL CUlohaView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return HtmlHelp(NULL,"sojko.chm::/ulohy.htm",HH_DISPLAY_TOPIC,0)!=NULL;
}

void CUlohaView::OnHelp() 
{
	HtmlHelp(NULL,"sojko.chm::/ulohy.htm",HH_DISPLAY_TOPIC,0);	
}
