// ZadanieView.cpp : implementation file
//

#include "stdafx.h"
#include "SOJ.h"
#include "ZadanieView.h"
#include "SojDoc.h"
#include "Pop.h"
#include "ImportMailDlg.h"
#include "ImportMedDlg.h"
#include "PwdDialog.h"
#include "HodnotDlg.h"
#include "ErrorReportDlg.h"
#include "EditZadDlg.h"
#include "ProgDlg.h"
#include "VysledkyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZadanieView

IMPLEMENT_DYNCREATE(CZadanieView, CFormView)

CZadanieView::CZadanieView()
	: CFormView(CZadanieView::IDD)
{
	//{{AFX_DATA_INIT(CZadanieView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CZadanieView::~CZadanieView()
{
}

void CZadanieView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CZadanieView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CZadanieView, CFormView)
	//{{AFX_MSG_MAP(CZadanieView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_ADD, OnImportMed)
	ON_BN_CLICKED(IDC_ADD2, OnImportMail)
	ON_COMMAND(ID_HODNOT, OnHodnot)
	ON_COMMAND(ID_REFRESH, OnRefresh)
	ON_NOTIFY(DGN_RCLICK, 60666, OnRClick)
	ON_NOTIFY(DGN_DBLCLICKED, 60666, OnDblClick)
	ON_COMMAND(ID_EDIT, OnEdit)
	ON_WM_HELPINFO()
	ON_COMMAND(ID_LOAD_MAIL, OnImportMail)
	ON_COMMAND(ID_LOAD_MED, OnImportMed)
	ON_BN_CLICKED(IDC_HODNOT, OnHodnot)
	ON_COMMAND(ID_HELP, OnHelp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZadanieView diagnostics

#ifdef _DEBUG
void CZadanieView::AssertValid() const
{
	CFormView::AssertValid();
}

void CZadanieView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CZadanieView message handlers

int CZadanieView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_oGrid.Create(this, 60666, WS_CHILD | WS_TABSTOP, WS_EX_CLIENTEDGE, CRect(0,0,0,0)))
		return -1;
	
	return 0;
}

void CZadanieView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	CSOJDoc * pDoc = (CSOJDoc*)GetDocument();
	GetDlgItem(IDC_ADD)->GetClientRect(m_btnRect);
	CStringArray m_aNames,m_aColumns;
	m_aNames.Add("Priezvisko");
	m_aColumns.Add("priezvisko");
	m_aNames.Add("Kr.");
	m_aColumns.Add("kruzok");
	m_aNames.Add("Ro.");
	m_aColumns.Add("rocnik");
	m_aNames.Add("Nzov");
	m_aColumns.Add("nazov");
	m_aNames.Add("Odovzdan");
	m_aColumns.Add("datum");
	m_aNames.Add("Body");
	m_aColumns.Add("body");
	m_aNames.Add("Poznmky");
	m_aColumns.Add("poznamky");
	m_rs.CreateInstance(__uuidof(Recordset));
//	m_rs->CursorLocation = adUseClient;
	try
	{
		m_rs->Open("SELECT * from odovzd",
			pDoc->m_db.GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);

		m_oGrid.OpenQuery(m_rs,m_aColumns,m_aNames);
		m_oGrid.SetColWidth(0,100);
		m_oGrid.SetColWidth(1,50);
		m_oGrid.SetColAlign(1,HDF_RIGHT );
		m_oGrid.SetColWidth(2,50);
		m_oGrid.SetColAlign(2,HDF_RIGHT );
		m_oGrid.SetColWidth(3,120);
		m_oGrid.SetColWidth(4,100);
		m_oGrid.SetColWidth(5,50);
		m_oGrid.SetColAlign(5,HDF_RIGHT );
		m_oGrid.SetColWidth(6,100);
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{	
		AfxMessageBox(IDS_EXCEPTION);
	}
}

void CZadanieView::OnSize(UINT nType, int cx, int cy) 
{
	if(m_btnRect.bottom>0)
	{
		m_oGrid.MoveWindow(5,5,cx-10,cy-30-m_btnRect.bottom);
		GetDlgItem(IDC_ADD)->
			MoveWindow(10,cy-m_btnRect.bottom-10,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_ADD2)->
			MoveWindow(10+5+m_btnRect.right,cy-m_btnRect.bottom-10,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_RAMIK)->
			MoveWindow(5,cy-m_btnRect.bottom-25,m_btnRect.right*2+5+10,m_btnRect.bottom+20);

		GetDlgItem(IDC_HODNOT)->
			MoveWindow(10+5+10+2*m_btnRect.right,cy-m_btnRect.bottom-10,m_btnRect.right,m_btnRect.bottom);
	}
}

BOOL CZadanieView::DestroyWindow() 
{
	m_rs->Close();	
	delete m_rs;
	return CFormView::DestroyWindow();
}

void CZadanieView::OnImportMed() 
{
	CString strSql;
	CImportMedDlg dlg;

	dlg.db=((CSOJDoc*)GetDocument())->m_db;
	COleDateTime datStart=COleDateTime::GetCurrentTime();
	if(dlg.DoModal()!=IDOK)
		return;
	COleDateTime datStop=COleDateTime::GetCurrentTime();

	if(dlg.m_bCheck)
		HromadKontrola(datStart,datStop);
	try
	{
		m_rs->Requery(NULL);
		m_oGrid.BindReQuery();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
	}	
}

void CZadanieView::OnImportMail() 
{
	CImportMailDlg dlg;
	CPop popTri;
	CString strServer = AfxGetApp()->GetProfileString("Settings","InMailServer");
	CString strName = AfxGetApp()->GetProfileString("Settings","InMailUser");
	CString pwd,strSql;
	if(	AfxGetApp()->GetProfileInt   ("Settings","InAsk",0) )
	{
		CPwdDialog dlg;
		CString strFormat = LPCSTR(IDS_HESLO);
		dlg.m_strNaz.Format(strFormat,_T("potov server"));
		if(dlg.DoModal()==IDOK)
		{
			pwd=dlg.m_strText;
		}
		else
		{
			return;
		}
	}
	else
	{
		CString str = "InMailPwd";
		pwd = AfxGetApp()->GetProfileString("Settings",str);
		Crypt(pwd,str);
	}

	CProgressDlg dlgProg;
	dlgProg.Create();
	dlgProg.SetStatus("Prebieha prihlasovanie na server");
	if(!popTri.Connect(strServer,110,strName,pwd))
	{
		AfxMessageBox("Nemono njs zadan server");
		return;
	}
	dlgProg.DestroyWindow();
	dlg.db=((CSOJDoc*)GetDocument())->m_db;
	dlg.SetPop(&popTri);

	COleDateTime datStart=COleDateTime::GetCurrentTime();
	if(dlg.DoModal()!=IDOK)
		return;
	COleDateTime datStop=COleDateTime::GetCurrentTime();

	if(dlg.m_bCheck)
		HromadKontrola(datStart,datStop);

	try
	{
		m_rs->Requery(NULL);
		m_oGrid.BindReQuery();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
	}	


}

void CZadanieView::OnHodnot() 
{
	CHodnotDlg dlg;
	dlg.m_nIdZadanie = m_oGrid.GetFieldValueLong("id_zadanie");
	dlg.db = ((CSOJDoc*)GetDocument())->m_db;
	if(dlg.DoModal()!=IDOK)
	{
		return;
	}
	
}

void CZadanieView::OnRefresh() 
{
	try
	{
		m_rs->Requery(NULL);
		m_oGrid.BindReQuery(TRUE);
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
	}	
}

void CZadanieView::OnRClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_ADOGRID * nmg = (NM_ADOGRID*)pNMHDR;
 	CMenu mPopup;
 	mPopup.CreatePopupMenu();
 	mPopup.InsertMenu(0,MF_BYPOSITION,ID_HODNOT, "&Hodnoti");
 	mPopup.SetDefaultItem(0,TRUE);
 	mPopup.InsertMenu(1,MF_SEPARATOR,0 );
	mPopup.InsertMenu(2,MF_BYPOSITION,ID_LOAD_MED, "Nata z &mdia");
	mPopup.InsertMenu(3,MF_BYPOSITION,ID_LOAD_MAIL, "Nata z &poty");
 	mPopup.InsertMenu(4,MF_SEPARATOR,0 );
	mPopup.InsertMenu(5,MF_BYPOSITION,ID_FILE_PRINT, "Tla");
	mPopup.InsertMenu(6,MF_BYPOSITION,ID_FILE_PRINT_PREVIEW, "Prehad");
 	mPopup.InsertMenu(7,MF_SEPARATOR,0 );
	mPopup.InsertMenu(8,MF_BYPOSITION,ID_HELP, "Npoveda");
 
 	mPopup.TrackPopupMenu(TPM_LEFTBUTTON|TPM_LEFTALIGN,nmg->pos.x,nmg->pos.y,this);
	m_oGrid.Invalidate();

}

void CZadanieView::OnDblClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnEdit();
}

void CZadanieView::OnEdit() 
{
	CEditZadDlg dlg;
	long nIdUloha,nIdZad;
	_variant_t var;
	CString strSql;

	try
	{
		nIdZad = m_oGrid.GetFieldValueLong("id_zadanie");
		var = m_rs->GetCollect("id_uloha");
		nIdUloha=(long)var;
		var = m_rs->GetCollect("datum");
		if(var.vt!=VT_NULL)
			dlg.m_strDat=(char*)((_bstr_t)(var));
		var = m_rs->GetCollect("priezvisko");
		if(var.vt!=VT_NULL)
			dlg.m_strPriezv=(char*)((_bstr_t)(var));
		var = m_rs->GetCollect("nazov");
		if(var.vt!=VT_NULL)
			dlg.m_strMeno=(char*)((_bstr_t)(var));

		_RecordsetPtr rs_zad;
		rs_zad.CreateInstance(__uuidof(Recordset));
		rs_zad->CursorLocation = adUseClient;
		strSql.Format("id_zadanie = %ld",nIdZad);
		rs_zad->Filter=_variant_t(strSql);
		rs_zad->Open("SELECT * from zadanie",((CSOJDoc*)GetDocument())->m_db.GetInterfacePtr(),
			adOpenStatic,
			adLockOptimistic,
			adCmdText);
		if(!rs_zad->adoEOF)
		{
			var = rs_zad->GetCollect("text");
			if(var.vt!=VT_NULL)
				dlg.m_strTextZad=(char*)((_bstr_t)(var));
		}
		rs_zad->Close();

		strSql.Format("id_uloha = %ld",nIdUloha);
		rs_zad->Filter=_variant_t(strSql);
		rs_zad->Open("SELECT * from uloha",((CSOJDoc*)GetDocument())->m_db.GetInterfacePtr(),
			adOpenStatic,
			adLockOptimistic,
			adCmdText);
		if(!rs_zad->adoEOF)
		{
			var = rs_zad->GetCollect("text");
			if(var.vt!=VT_NULL)
				dlg.m_strTextUl=(char*)((_bstr_t)(var));
			dlg.m_strTextZad.Replace("\n","\r\n");
		}
		rs_zad->Close();

	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		m_oGrid.EnableWindow();
		return;
	}	
	dlg.DoModal();

}

void CZadanieView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	m_oGrid.OnPrepareDC(pDC,pInfo);
}

BOOL CZadanieView::OnPreparePrinting(CPrintInfo* pInfo) 
{
	m_oGrid.OnPreparePrinting(pInfo);
	return DoPreparePrinting(pInfo);
}

void CZadanieView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CFont   * fHead = new CFont;
	LOGFONT lf;
	CSize sVal;

	fHead->CreatePointFont(180,"Arial New",pDC);
	fHead->GetLogFont(&lf);
	lf.lfCharSet=EASTEUROPE_CHARSET ; //EE;
	lf.lfWeight = FW_BOLD;
	delete fHead; fHead = new CFont;
	fHead->CreateFontIndirect(&lf);
	CFont *pOldF = pDC->SelectObject(fHead);

	CRect rcText(pInfo->m_rectDraw.left,pInfo->m_rectDraw.top, pInfo->m_rectDraw.right,pInfo->m_rectDraw.bottom);

	CString strNaz = CString(LPCSTR(IDS_ZADANIE)),strCen;
	pDC->DrawText(strNaz, &rcText, DT_CENTER| DT_SINGLELINE | DT_NOPREFIX | DT_END_ELLIPSIS);
	sVal = pDC->GetTextExtent(strNaz);

	delete fHead;fHead = new CFont;
	fHead->CreatePointFont(140,"Arial New",pDC);
	fHead->GetLogFont(&lf);
	lf.lfCharSet=EASTEUROPE_CHARSET ; //EE;
	delete fHead; 
	
	m_oGrid.OnPrint(pDC, pInfo);
}

BOOL CZadanieView::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	if(wParam==WM_USER)
	{
		if(((NMHDR*)lParam)->code==0)
		{
			m_oGrid.CleanUp();
			m_rs->Close();
		}
		else
		{
			OnInitialUpdate();
			m_oGrid.Invalidate();
		}
		return TRUE;
	}
	else
		return CFormView::OnNotify(wParam, lParam, pResult);
}

void CZadanieView::HromadKontrola(COleDateTime datOd, COleDateTime datDo)
{
	long nIdZad,nCount=0;
	CString strSql;
	CHodnot pHodnot;
	CVysledkyDlg * dlgVys = new CVysledkyDlg;
	dlgVys->Create(IDD_VYSL);
	dlgVys->ShowWindow(SW_SHOW);
	try
	{
		_RecordsetPtr rsCheck;
		rsCheck.CreateInstance(__uuidof(Recordset));

		pHodnot.db = ((CSOJDoc*)GetDocument())->m_db;
		pHodnot.lst = &dlgVys->m_lstVys;
		dlgVys->ShowWindow(SW_SHOW);
		strSql.Format(
			"SELECT zadanie.id_zadanie, zadanie.datum "
			"FROM zadanie "
			"WHERE (((zadanie.datum)>=#%s#) AND ((zadanie.datum)<=#%s#))"			,
			datOd.Format("%m/%d/%Y %H:%M:%S"),datDo.Format("%m/%d/%Y %H:%M:%S"));
		rsCheck->Open(_variant_t(strSql),
			(((CSOJDoc*)GetDocument())->m_db).GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);
		while(!rsCheck->adoEOF)
		{
			nIdZad = rsCheck->GetCollect(L"id_zadanie");
			pHodnot.Porovn(nIdZad);
			nCount++;
			rsCheck->MoveNext();
		}
		rsCheck->Close();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		return;
	}	
	if(!nCount)
		dlgVys->DestroyWindow();

}

BOOL CZadanieView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return HtmlHelp(NULL,"sojko.chm::/zadania.htm",HH_DISPLAY_TOPIC,0)!=0;
}

void CZadanieView::OnHelp() 
{
HtmlHelp(NULL,"sojko.chm::/zadania.htm",HH_DISPLAY_TOPIC,0);	
}
