// StudentView.cpp : implementation file
//

#include "stdafx.h"
#include "SOJ.h"
#include "StudentView.h"
#include "SOJDoc.h"
#include "EditStudent.h"
#include "ErrorReportDlg.h"
#include "ProgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStudentView

IMPLEMENT_DYNCREATE(CStudentView, CFormView)

CStudentView::CStudentView()
	: CFormView(CStudentView::IDD)
{
	//{{AFX_DATA_INIT(CStudentView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CStudentView::~CStudentView()
{
}

void CStudentView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStudentView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStudentView, CFormView)
	//{{AFX_MSG_MAP(CStudentView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_NOTIFY(DGN_DBLCLICKED, 60666, OnDblClick)
	ON_NOTIFY(DGN_COLUMNCLICK, 60666, OnColumnClick)
	ON_COMMAND(ID_REFRESH, OnRefresh)
	ON_NOTIFY(DGN_RCLICK, 60666, OnRClick)
	ON_BN_CLICKED(IDC_IMPORT, OnImport)
	ON_WM_HELPINFO()
	ON_COMMAND(ID_ADD, OnAdd)
	ON_COMMAND(ID_DEL, OnDel)
	ON_COMMAND(ID_EDIT, OnEdit)
	ON_COMMAND(ID_HELP, OnHelp)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStudentView diagnostics

#ifdef _DEBUG
void CStudentView::AssertValid() const
{
	CFormView::AssertValid();
}

void CStudentView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CStudentView message handlers

void CStudentView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	CSOJDoc * pDoc = (CSOJDoc*)GetDocument();
	GetDlgItem(IDC_ADD)->GetClientRect(m_btnRect);
	CStringArray m_aNames,m_aColumns;
	m_aNames.Add("Os.slo");
	m_aColumns.Add("id_student");
	m_aNames.Add("Priezvisko");
	m_aColumns.Add("priezvisko");
	m_aNames.Add("Meno");
	m_aColumns.Add("meno");
	m_aNames.Add("Krok");
	m_aColumns.Add("kruzok");
	m_aNames.Add("Ronk");
	m_aColumns.Add("rocnik");
	m_aNames.Add("e-mail");
	m_aColumns.Add("email");
	m_aNames.Add("Poznmky");
	m_aColumns.Add("poznamky");

	try
	{
		m_rs.CreateInstance(__uuidof(Recordset));
		m_rs->CursorLocation = adUseClient;
		m_rs->Open("SELECT * from student",
			pDoc->m_db.GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);
		m_oGrid.OpenQuery(m_rs,m_aColumns,m_aNames);
		m_oGrid.SetColWidth(0,60);
		m_oGrid.SetColAlign(0,HDF_RIGHT );
		m_oGrid.SetColWidth(1,120);
		m_oGrid.SetColWidth(2,100);
		m_oGrid.SetColWidth(3,50);
		m_oGrid.SetColAlign(3,HDF_RIGHT );
		m_oGrid.SetColWidth(4,50);
		m_oGrid.SetColAlign(4,HDF_RIGHT );
		m_oGrid.SetColWidth(5,100);
		m_oGrid.SetColWidth(6,100);

	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{	
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
	}
}

int CStudentView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_oGrid.Create(this, 60666, WS_CHILD | WS_TABSTOP, WS_EX_CLIENTEDGE, CRect(0,0,110,110)))
		return -1;
	return 0;
}

void CStudentView::OnSize(UINT nType, int cx, int cy) 
{
	if(m_btnRect.bottom>0)
	{
		m_oGrid.MoveWindow(5,5,cx-10,cy-20-m_btnRect.bottom);
		GetDlgItem(IDC_ADD)->
			MoveWindow(5,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_EDIT)->
			MoveWindow(10+m_btnRect.right,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_DEL)->
			MoveWindow(5+2*m_btnRect.right+10,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);
		GetDlgItem(IDC_IMPORT)->
			MoveWindow(5+3*m_btnRect.right+15,cy-m_btnRect.bottom-5,m_btnRect.right,m_btnRect.bottom);
	}
}

void CStudentView::OnAdd() 
{
	CEditStudent dlg;
	_variant_t var;
	if(dlg.DoModal()==IDOK)
	{
		try
		{
			m_rs->AddNew();
			var = dlg.m_strId;
			m_rs->GetFields()->GetItem(_variant_t("id_student"))->Value = var;
			var.vt=VT_I4;
			var.lVal=dlg.m_nKr;
			m_rs->GetFields()->GetItem(_variant_t("kruzok"))->Value = var;
			var.lVal=dlg.m_nRoc;
			m_rs->GetFields()->GetItem(_variant_t("rocnik"))->Value = var;
			var = dlg.m_strMeno;
			m_rs->GetFields()->GetItem(_variant_t("meno"))->Value = var;
			var = dlg.m_strPriezv;
			m_rs->GetFields()->GetItem(_variant_t("priezvisko"))->Value = var;
			var = dlg.m_strMail;
			m_rs->GetFields()->GetItem(_variant_t("email"))->Value = var;
			var = dlg.m_strPozn;
			m_rs->GetFields()->GetItem(_variant_t("poznamky"))->Value = var;
			m_rs->Update();
//			m_rs->Requery();
			m_oGrid.BindReQuery(TRUE);
		}
		catch(CException *e)
		{
			e->ReportError();
		}
		catch(_com_error &e)
		{
			AfxMessageBox(e.ErrorMessage());
		}
		catch(...)
		{
			CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		}	
	}
}

void CStudentView::OnEdit() 
{
	m_oGrid.EnableWindow(FALSE);
	CEditStudent dlg;
	_variant_t var,varId;
	long id_student;
	try
	{
		id_student = m_oGrid.GetFieldValueLong("id_student");
		dlg.m_strId.Format("%05ld",id_student);
		
		var = m_rs->GetCollect("kruzok");
		dlg.m_nKr=(long)var;
		var = m_rs->GetCollect("rocnik");
		dlg.m_nRoc=(long)var;
		var = m_rs->GetCollect("meno");
		if(var.vt!=VT_NULL)
			dlg.m_strMeno=GETSTRING(var);
		var = m_rs->GetCollect("priezvisko");
		if(var.vt!=VT_NULL)
			dlg.m_strPriezv=GETSTRING(var);
		var = m_rs->GetCollect("email");
		if(var.vt!=VT_NULL)
			dlg.m_strMail=GETSTRING(var);
		var = m_rs->GetCollect(L"poznamky");
		if(var.vt!=VT_NULL)
			dlg.m_strPozn=GETSTRING(var);


	}
	catch(CException *e)
	{
		e->Delete();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch( SEH_Exception &e )   
	{
		CString strErr;
		strErr.Format("Error Code %08lx\n", e.getSeHNumber() );
		CErrorReportDlg(strErr).DoModal();
		
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		m_oGrid.EnableWindow();
		return;
	}	
	if(dlg.DoModal()==IDOK)
	{
		try
		{
			CString strFind;
			strFind.Format("id_student=%05ld",id_student);
			m_rs->MoveFirst();
			m_rs->Find(bstr_t(strFind),0,adSearchForward);
			if(m_rs->adoEOF)	// nenasiel
				return;


			var.vt=VT_I4;
			var.lVal=dlg.m_nKr;
			m_rs->GetFields()->GetItem(_variant_t("kruzok"))->Value = var;
			var.lVal=dlg.m_nRoc;
			m_rs->GetFields()->GetItem(_variant_t("rocnik"))->Value = var;
			var = dlg.m_strMeno;
			m_rs->GetFields()->GetItem(_variant_t("meno"))->Value = var;
			var = dlg.m_strPriezv;
			m_rs->GetFields()->GetItem(_variant_t("priezvisko"))->Value = var;
			var = dlg.m_strMail;
			m_rs->GetFields()->GetItem(_variant_t("email"))->Value = var;
			var = dlg.m_strPozn;
			m_rs->GetFields()->GetItem(_variant_t("poznamky"))->Value = var;
			m_rs->Update();
			m_oGrid.Invalidate();

		}
		catch(_com_error *e)
		{
			AfxMessageBox(e->ErrorMessage());
		}
		catch(...)
		{
			CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		}	
	}
	m_oGrid.EnableWindow();
}

void CStudentView::OnDel() 
{
	m_oGrid.EnableWindow(FALSE);
	if(AfxMessageBox("Naozaj si elte vymaza tudenta ??",MB_YESNO|MB_DEFBUTTON2)==IDYES)
	{
		try
		{
			long id_student = m_oGrid.GetFieldValueLong("id_student");
			CString strFind;
			strFind.Format("id_student=%05ld",id_student);
			m_rs->MoveFirst();
			m_rs->Find(bstr_t(strFind),0,adSearchForward);
			if(m_rs->adoEOF)	// nenasiel
				return;

			m_rs->Delete(adAffectCurrent);
			m_rs->Update();
			m_oGrid.BindReQuery(TRUE);
			//Refresh();
		}
		catch(_com_error *e)
		{
			AfxMessageBox(e->ErrorMessage());
		}
		catch(...)
		{
			CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db).DoModal();
		}	
	}
	m_oGrid.EnableWindow();
}

BOOL CStudentView::DestroyWindow() 
{
	m_rs->Close();
	delete m_rs;
	return CFormView::DestroyWindow();
}


void CStudentView::OnDblClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnEdit();
}

void CStudentView::OnRefresh() 
{
	m_rs->Requery(NULL);
	m_rs->MoveFirst();
	m_oGrid.BindReQuery();
}

void CStudentView::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_ADOGRID * nmg = (NM_ADOGRID*)pNMHDR;
	CSOJDoc * pDoc = (CSOJDoc*)GetDocument();
	CString strSql;
	try
	{
		m_rs->Close();
		strSql = "SELECT * from student ORDER BY "+nmg->strCol;
		m_rs->Open(_variant_t(strSql),
			pDoc->m_db.GetInterfacePtr(),
			adOpenDynamic,
			adLockOptimistic,
			adCmdText);
		m_rs->MoveFirst();
		m_oGrid.BindReQuery();
	}
	catch(_com_error *e)
	{
		AfxMessageBox(e->ErrorMessage());
	}
	catch(...)
	{
		CErrorReportDlg(((CSOJDoc*)GetDocument())->m_db,this).DoModal();
	}	
}

void CStudentView::OnRClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_ADOGRID * nmg = (NM_ADOGRID*)pNMHDR;
 	CMenu mPopup;
 	mPopup.CreatePopupMenu();
 	mPopup.InsertMenu(0,MF_BYPOSITION,ID_EDIT, "Upravi");
 	mPopup.InsertMenu(1,MF_SEPARATOR,0 );
 	mPopup.SetDefaultItem(0,TRUE);
	mPopup.InsertMenu(2,MF_BYPOSITION,ID_ADD, "Prida");
	mPopup.InsertMenu(3,MF_BYPOSITION,ID_ADD, "Vymaza");
 	mPopup.InsertMenu(4,MF_SEPARATOR,0 );
	mPopup.InsertMenu(5,MF_BYPOSITION,ID_FILE_PRINT, "Tla");
	mPopup.InsertMenu(6,MF_BYPOSITION,ID_FILE_PRINT_PREVIEW, "Prehad");
 	mPopup.InsertMenu(7,MF_SEPARATOR,0 );
	mPopup.InsertMenu(8,MF_BYPOSITION,ID_HELP, "Npoveda");
 
 	mPopup.TrackPopupMenu(TPM_LEFTBUTTON|TPM_LEFTALIGN,nmg->pos.x,nmg->pos.y,this);
	m_oGrid.Invalidate();

}

void CStudentView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo) 
{
	m_oGrid.OnPrepareDC(pDC,pInfo);
}

BOOL CStudentView::OnPreparePrinting(CPrintInfo* pInfo) 
{
	m_oGrid.OnPreparePrinting(pInfo);
	return DoPreparePrinting(pInfo);
}

void CStudentView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	CFont   * fHead = new CFont;
	LOGFONT lf;
	CSize sVal;

	fHead->CreatePointFont(180,"Arial New",pDC);
	fHead->GetLogFont(&lf);
	lf.lfCharSet=EASTEUROPE_CHARSET ; //EE;
	lf.lfWeight = FW_BOLD;
	delete fHead; fHead = new CFont;
	fHead->CreateFontIndirect(&lf);
	CFont *pOldF = pDC->SelectObject(fHead);

	CRect rcText(pInfo->m_rectDraw.left,pInfo->m_rectDraw.top, pInfo->m_rectDraw.right,pInfo->m_rectDraw.bottom);

	CString strNaz = CString(LPCSTR(IDS_STUDENT)),strCen;
	pDC->DrawText(strNaz, &rcText, DT_CENTER| DT_SINGLELINE | DT_NOPREFIX | DT_END_ELLIPSIS);
	sVal = pDC->GetTextExtent(strNaz);

	delete fHead;fHead = new CFont;
	fHead->CreatePointFont(140,"Arial New",pDC);
	fHead->GetLogFont(&lf);
	lf.lfCharSet=EASTEUROPE_CHARSET ; //EE;
	delete fHead; 
	
	m_oGrid.OnPrint(pDC, pInfo);
}



BOOL CStudentView::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	if(wParam==WM_USER)
	{
		if(((NMHDR*)lParam)->code==0)
		{
			m_oGrid.CleanUp();
			m_rs->Close();
		}
		else
		{
			OnInitialUpdate();
			m_oGrid.Invalidate();
		}
	}
	
	return CFormView::OnNotify(wParam, lParam, pResult);
}

void CStudentView::OnImport() 
{

	int nPos;
	_variant_t var;
	CFileDialog dlg(TRUE);
	if(dlg.DoModal()!=IDOK)
		return;

	int nHead	  = AfxGetApp()->GetProfileInt("Settings","IHead",18);
	int nRocPos = AfxGetApp()->GetProfileInt("Settings","IRocPos",5	);
	int nRocLen =  AfxGetApp()->GetProfileInt("Settings","IRocLen",2	);
	int nKruzPos =  AfxGetApp()->GetProfileInt("Settings","IKruzPos",12	);
	int nKruzLen =  AfxGetApp()->GetProfileInt("Settings","IKruzLen",2	);
	int nIdPos =  AfxGetApp()->GetProfileInt("Settings","IIdPos",24	);
	int nIdLen =  AfxGetApp()->GetProfileInt("Settings","IIdLen",6	);
	int nMenoPos =  AfxGetApp()->GetProfileInt("Settings","IMenoPos",31	);
	int nMenoLen =  AfxGetApp()->GetProfileInt("Settings","IMenoLen",100);

	
	CProgressDlg dlgProg;
	dlgProg.Create();
	dlgProg.SetStatus("Prebieha import tudentov");
	CString strLine,strTmp;
	CString strKruz,strRoc,strId,strMeno,strPriezv;
	try
	{
		CStdioFile fImport(dlg.GetPathName(),CFile::modeRead);
		while(fImport.ReadString(strLine))
		{
			if(! --nHead)
				break;
		}
		if(nHead)
		{
			AfxMessageBox("Nesprvny formt sboru");
			return;
		}
		int first = 1;
		while(fImport.ReadString(strLine))
		{
			if(strLine.IsEmpty())
				continue;
			strRoc		= strLine.Mid(nRocPos,nRocLen);
			strKruz		= strLine.Mid(nKruzPos,nKruzLen);
			strTmp		= strLine.Mid(nIdPos,nIdLen);
			strTmp.Remove(' ');
			strId		= strTmp;
			strTmp		= strLine.Mid(nMenoPos,nMenoLen);
			strTmp.OemToAnsi();
			nPos = strTmp.Find(' ');
			strPriezv	= strTmp.Left(nPos);
			strMeno		= strTmp.Mid(nPos+1);

			if(first)
			{
				if(m_oGrid.IsBound())
					m_rs->MoveFirst();
			}
			else
			{
				m_rs->MoveFirst();
			}
			strTmp.Format("id_student=%s",strId);
			m_rs->Find(_bstr_t(strTmp),0,adSearchForward);
			if(m_rs->adoEOF)
				m_rs->AddNew();
			else
				continue;
			var = strRoc;
			m_rs->GetFields()->GetItem(_variant_t("rocnik"))->Value = var;
			var = strKruz;
			m_rs->GetFields()->GetItem(_variant_t("kruzok"))->Value = var;
			var = strId;
			m_rs->GetFields()->GetItem(_variant_t("id_student"))->Value = var;
			var = strPriezv;
			m_rs->GetFields()->GetItem(_variant_t("priezvisko"))->Value = var;
			var = strMeno;
			m_rs->GetFields()->GetItem(_variant_t("meno"))->Value = var;
			m_rs->Update();
		}
		fImport.Close();
	}
	catch(CException *e)
	{
		e->Delete();
	}
	catch(...)
	{
		AfxMessageBox("Unknown error...");
	}
	dlgProg.DestroyWindow();
	OnRefresh();
	
}

BOOL CStudentView::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return HtmlHelp(NULL,"sojko.chm::/student.htm",HH_DISPLAY_TOPIC,0)!=NULL;
}

void CStudentView::OnHelp() 
{
	HtmlHelp(NULL,"sojko.chm::/student.htm",HH_DISPLAY_TOPIC,0);
}
