#include "team2.h"
#include "utils.h"

priradenia::priradenia(char* subor)
{
	prve=(priradenie*)0;
	//ulozime si meno suboru
	this->subor=new char[strlen(subor)+1];
	strcpy(this->subor,subor);

	//nacitaj priradenia zo suboru
	nacitaj();

	//zatial ziadna zmena
	zmena=0;
}

priradenia::~priradenia()
{
	//test na zmenu obsahu priradeni
	if(zmena)
		//ulozime to do suboru
		uloz();
}

int priradenia::vykonaj(char* cesta, int poradie)
{
	char* pripona=(char*)0;
	char* adresar=(char*)0;
	priradenie* aktualne=prve;
	prikaz* aktualny;
	int i, proces;
	char** argumenty;

	//vytvor pole argumentov
	argumenty=cesta_argumenty(cesta);
	//zisti o aku priponu ide
	pripona=vyber_priponu(argumenty[0]);
	//zisti kde to chceme spustit
	adresar=vyber_cestu(argumenty[0]);
	if(!strcmp(pripona,"exe") || !strcmp(pripona,"com") || !strcmp(pripona,"bat"))
	{
		char cwd[512];
		getcwd(cwd,512);
		//presun sa do pracovneho adresara
		chdir(adresar);
		//je to spustitelny subor, tak ho spusti
		proces=spawnv(_P_WAIT,argumenty[0],argumenty);
		//presun sa naspat
		chdir(cwd);
		return proces;
	}
	else
	{
		if(*pripona=='\0')
			return -1;
		for(aktualne=prve;aktualne;aktualne=aktualne->dalsie)
		{
			if(!strcmp(aktualne->pripona,pripona))
				break;
		}
		//v aktualne->prikazy je teraz subor prikazov pre priponu
		//ak je NULL, nenasla sa taka pripona
		if(!aktualne)
			return -1;
		//ak su prikazy pre priponu
		if(aktualne->prikazy)
		{
			char cwd[512];
			getcwd(cwd,512);
			//chod do pracovneho adresara
			chdir(adresar);
			//v poradie je index prikazu v zretazenom zozname
			for(i=0,aktualny=aktualne->prikazy;i<poradie && aktualny->dalsi;i++,aktualny=aktualny->dalsi);
			//v aktualny mame teraz prikaz pre priponu
			if(aktualny->argumenty)
				proces=spawnlp(_P_WAIT,aktualny->cesta,aktualny->cesta, aktualny->argumenty, cesta, NULL);
			else
				proces=spawnlp(_P_WAIT,aktualny->cesta,aktualny->cesta, cesta,NULL);
			//vrat sa naspat
			chdir(cwd);
			return proces;
		}
		else
			return -1;
	}
}

int priradenia::pridaj(char* pripona, char* cesta)
{
	priradenie* aktualne=(priradenie*)0;
	priradenie* nove=(priradenie*)0;
	prikaz* aktualny=(prikaz*)0;
	prikaz* novy=(prikaz*)0;
	char* pozicia=(char*)0;
	char pismeno;
	int i=0;

	for(aktualne=prve;aktualne;aktualne=aktualne->dalsie)
	{
		if(!strcmp(pripona,aktualne->pripona))
			break;
		nove=aktualne;
	}
	if(!aktualne)
	{
		aktualne=nove;
		nove=new priradenie;
		nove->pripona=new char[strlen(pripona)+1];
		nove->dalsie=(priradenie*)0;
		strcpy(nove->pripona, pripona);
		nove->prikazy=(prikaz*)0;
		aktualne->dalsie=nove;
		aktualne=nove;
	}
	if(aktualne->prikazy)
	{
		for(aktualny=aktualne->prikazy;aktualny->dalsi && strcmp(aktualny->cesta,cesta);i++,aktualny=aktualny->dalsi);
		if(strcmp(aktualny->cesta,cesta))
		{
			aktualny->dalsi=new prikaz;
			aktualny=aktualny->dalsi;
			aktualny->dalsi=(prikaz*)0;
			i++;
		}
		else
			return i;
	}
	else
	{
		aktualny=new prikaz;
		aktualny->dalsi=(prikaz*)0;
		aktualne->prikazy=aktualny;
	}
	pozicia=preskoc_prazdne(cesta);
	pozicia=preskoc_plne(pozicia);
	pismeno=*pozicia;
	*pozicia='\0';
	aktualny->cesta=new char[pozicia-cesta+1];
	strcpy(aktualny->cesta, cesta);
	*pozicia=pismeno;
	if(pismeno)
	{
		pozicia=preskoc_prazdne(pozicia);
		aktualny->argumenty=new char[strlen(pozicia)+1];
		strcpy(aktualny->argumenty, pozicia);
	}
	else
	{
		aktualny->argumenty=(char*)0;
	}
	zmena=1;
	
	return i;
}

int priradenia::odober(char* pripona, int poradie)
{
	int i;
	priradenie* aktualne=(priradenie*)0;
	prikaz* aktualny=(prikaz*)0;
	prikaz* predchadzajuci=(prikaz*)0;

	for(aktualne=prve;aktualne;aktualne=aktualne->dalsie)
	{
		if(!strcmp(aktualne->pripona,pripona))
			break;
	}
	//v aktualne->prikazy je teraz subor prikazov pre priponu
	//ak je NULL, nenasla sa taka pripona
	if(!aktualne)
		return -1;
	//ak su prikazy
	if(aktualne->prikazy)
	{
		//v poradie je index prikazu v zretazenom zozname
		for(i=0,aktualny=aktualne->prikazy;i<poradie && aktualny->dalsi;i++,predchadzajuci=aktualny,aktualny=aktualny->dalsi);
		//odober iba ak sa nasiel
		if(i==poradie)
		{
			//v aktualny mame teraz prikaz pre priponu
			if(aktualny->argumenty)
			{
				delete[] aktualny->argumenty;
			}
			if(aktualny->cesta)
			{
				delete[] aktualny->cesta;
			}
			predchadzajuci->dalsi=aktualny->dalsi;
			delete aktualny;
			zmena=1;
		}
	}

	return 0;
}

//z inicializacneho suboru nacita priradenia
void priradenia::nacitaj()
{
	//premenne pre pracu s textom
	char* text=(char*)0;
	char* pozicia1=(char*)0;
	char* pozicia2=(char*)0;
	char pismeno;

	//premenne pre ukladanie nacitanych priradeni
	priradenie* nove=(priradenie*)0;
	priradenie* predchadzajuce=(priradenie*)0;
	prikaz* novy=(prikaz*)0;
	prikaz* predchadzajuci=(prikaz*)0;

	//nacitame subor do lokalnej pamate
	if(citaj(subor,&text)==-1)
		return;
	pis("priradenia.old",text, strlen(text));
	prve=(priradenie*)0;

	//hlavna slucka
	while(1)
	{
		//nacitaj priponu

		//preskoc prazdne znaky
		text=preskoc_prazdne(text);
		//ak sme na konci textu, vyskocime z cyklu
		if(*text=='\0')
			break;
		//posuniewme sa za priponu
		pozicia1=preskoc_plne(text);
		//otestuj dvojbodku
		if(*(pozicia1-1)==':')
			pozicia2=--pozicia1;
		else
			pozicia2=preskoc_prazdne(pozicia1);
		if(*pozicia2++==':')
		{
			//je to pripona!

			//vytvor zretazenie
			nove=new priradenie;
			nove->dalsie=(priradenie*)0;
			if(predchadzajuce)
				predchadzajuce->dalsie=nove;
			else
				prve=nove;
			predchadzajuce=nove;
			//uchovame si co tam bolo predtym
			pismeno=*pozicia1;
			//skopirujeme nulou ukonceny retazec
			*pozicia1='\0';
			nove->pripona=new char[pozicia1-text+1];
			strcpy(nove->pripona,text);
			//vratime povodnu hodnotu
			*pozicia1=pismeno;
			nove->prikazy=(prikaz*)0;
			predchadzajuci=(prikaz*)0;
		}
		else
		{
			//nie je to pripona, ale prikaz!
			pozicia2=text;
			//teda budeme pokracovat pre predchadzajucu priponu
		}
		while(1)
		{
			//tu uz su jednotlive prikazy

			//nacitaj prikaz
			pozicia1=preskoc_prazdne(pozicia2);
			pozicia2=preskoc_plne(pozicia1);
			//test na novy riadok
			if(*pozicia1=='\n')
			{
				//mozny koniec zoznamu prikazov
				text=pozicia1+1;
				break;
			}
			//test na koniec suboru
			if(*pozicia1=='\0')
			{
				//sme na konci
				text=pozicia1;
				break;
			}
			//uchovaj si co tam bolo
			pismeno=*pozicia2;
			//retazec ukonci nulou
			*pozicia2='\0';
			if(*pozicia1=='/' || *pozicia1=='-')
			{
				//je to prepinac

				char* argumenty=(char*)0;
				//ak nie je prikaz, nebudu ani argumenty
				if(novy==(prikaz*)0)
					break;
				//vytvor pole argumentov
				if(argumenty=novy->argumenty)
				{
					//pridame k uz existujucim
					novy->argumenty=new char[pozicia2-pozicia1+strlen(argumenty)+1];
					strcpy(novy->argumenty,argumenty);
					strcat(novy->argumenty,pozicia1);
					delete argumenty;
				}
				else
				{
					//treba vytvorit nove
					novy->argumenty=new char[pozicia2-pozicia1+1];
					strcpy(novy->argumenty,pozicia1);
				}
			}
			else
			{
				//je to prikaz

				//vytvor zretazenie
				novy=new prikaz;
				novy->dalsi=(prikaz*)0;
				if(predchadzajuci)
					predchadzajuci->dalsi=novy;
				else
					nove->prikazy=novy;
				predchadzajuci=novy;
				//skopiruj nulou ukonceny retazec
				novy->cesta=new char[pozicia2-pozicia1+1];
				novy->argumenty=(char*)0;
				strcpy(novy->cesta,pozicia1);
			}
 			//obnov povodne
			*pozicia2=pismeno;
		}
	}
}

void priradenia::uloz()
{
	priradenie* aktualne=prve;
	prikaz* aktualny;
	char* bufer=(char*)0;
	char* pozicia;
	int dlzka=0;

	//vypocitaj, kolko miesta si mas vyhradit
	while(aktualne)
	{
		//priratame priponu
		dlzka+=strlen(aktualne->pripona);
		//medzera, dvojbodka, medzera
		dlzka+=3;
		aktualny=aktualne->prikazy;
		//prejdi vsetky prikazy
		while(aktualny)
		{
			//priratame prikaz
			dlzka+=strlen(aktualny->cesta);
			//medzera medzi prikazom a argumentami
			dlzka++;
			if(aktualny->argumenty)
			{
				//priratame argumenty
				dlzka+=strlen(aktualny->argumenty);
				//medzera medzi prikazmi, alebo nl
				dlzka++;
			}
			//dalsi prikaz
			aktualny=aktualny->dalsi;
		}
		aktualne=aktualne->dalsie;
	}
	bufer=new char[dlzka];
	pozicia=bufer;
	aktualne=prve;
	//vloz postupne pripony a prikazy
	while(aktualne)
	{
		//vlozime priponu
		strcpy(pozicia, aktualne->pripona);
		pozicia+=strlen(aktualne->pripona);
		//medzera, dvojbodka, medzera
		strcpy(pozicia, " :");
		pozicia+=2;
		aktualny=aktualne->prikazy;
		//vloz vsetky prikazy
		while(aktualny)
		{
			//vlozime medzeru medzi prikazy
			*pozicia++=' ';
			//vlozime prikaz
			strcpy(pozicia, aktualny->cesta);
			pozicia+=strlen(aktualny->cesta);
			if(aktualny->argumenty)
			{
				//medzera medzi prikazom a argumentami
				*pozicia++=' ';
				//vlozime argumenty
				strcpy(pozicia, aktualny->argumenty);
				pozicia+=strlen(aktualny->argumenty);
			}
			//dalsi prikaz
			aktualny=aktualny->dalsi;
		}
		//za prikazmi novy riadok
		*pozicia++='\n';
		aktualne=aktualne->dalsie;
	}
	pis(subor, bufer, dlzka);
}
