#include "utils.h"

int citaj(char* subor,char** bufer)
{
	int fd, dlzka;
	
	fd=_open(subor,O_RDONLY);
	if(fd==-1)
		return -1;
	dlzka=_lseek(fd,0,SEEK_END);
	if(dlzka<0)
	{
		_close(fd);
		return -1;
	}
	if(dlzka==0)
	{
		_close(fd);
		return 0;
	}
	(*bufer)=new char[dlzka];
	_lseek(fd,0,SEEK_SET);
	dlzka=_read(fd,*bufer,dlzka);
	_close(fd);
	if(dlzka==-1)
	{
		delete (*bufer);
		return -1;
	}
	else
	{
		(*bufer)[dlzka]='\0';
	}
	return dlzka;
}

int pis(char* subor,char* bufer,int kolko)
{
	int dlzka;
	int fd=_open(subor,O_WRONLY|O_CREAT|O_TRUNC);
	if(fd==-1)
		return -1;
	_lseek(fd,0,SEEK_SET);
	dlzka=_write(fd,bufer,kolko);
	_close(fd);
	return dlzka;
}

char* preskoc_prazdne(char* text)
{
	while(*text==' ' || *text=='\t') text++;
	return text;
}

char* preskoc_plne(char* text)
{
	while(*text!=' ' && *text!='\t' && *text!='\n' && *text!='\0') text++;
	return text;
}

char* vyber_priponu(char* cesta)
{
	char* koniec;
	char* zaciatok;
	char* pripona;
	char pismeno;

//	while(*zaciatok && *zaciatok++!='.');
	koniec=preskoc_plne(cesta);
	pismeno=*koniec;
	*koniec='\0';
	zaciatok=koniec-1;
	while(*zaciatok!='.' && zaciatok-->cesta);
	if(zaciatok==cesta)
		zaciatok=koniec;
	else
		zaciatok++;
	pripona=new char[koniec-zaciatok+1];
	strcpy(pripona,zaciatok);
	*koniec=pismeno;
	return pripona;
}

char* vyber_cestu(char* cesta)
{
	char* koniec;
	char* zaciatok;
	char* pripona;
	char pismeno;

	koniec=preskoc_plne(cesta);
	zaciatok=koniec-1;
	while(*zaciatok!='\\' && zaciatok-->cesta);
	pismeno=*zaciatok;
	*zaciatok=0;
	pripona=new char[zaciatok-cesta+1];
	strcpy(pripona,cesta);
	*zaciatok=pismeno;
	return pripona;
}

char* vyber_meno(char* cesta)
{
		char* koniec;
	char* zaciatok;
	char* pripona;
	char pismeno;

	koniec=preskoc_plne(cesta);
	zaciatok=koniec-1;
	while(*zaciatok!='.' && zaciatok-->cesta);
	if(zaciatok==cesta)
		zaciatok=koniec;
	pismeno=*zaciatok;
	*zaciatok=0;
	zaciatok--;
	pripona=new char[zaciatok-cesta+1];
	strcpy(pripona,cesta);
	*zaciatok=pismeno;
	return pripona;
}

char** cesta_argumenty(char* cesta)
{
	int dlzka=strlen(cesta)+1;
	char* pozicia1;
	char* pozicia2=cesta;
	int pocet=0;
	int i=0;
	char** argumenty;
	while(1)
	{
		pozicia1=preskoc_prazdne(pozicia2);
		pozicia2=preskoc_plne(pozicia1);
		pocet++;
		if(*pozicia2=='\0')
			break;
	}
	argumenty=new char*[pocet+1];
	pozicia2=cesta;
	while(i<pocet)
	{
		pozicia1=preskoc_prazdne(pozicia2);
		pozicia2=preskoc_plne(pozicia1);
		*pozicia2++='\0';
		argumenty[i++]=pozicia1;
	}
	argumenty[i]=(char*)0;
	return argumenty;
}